﻿using System.Windows;

namespace GameCore
{
    public class GeometryHelpers
    {
        public static bool PointInParralellogram(Point pt, Point v1, Point v2, Point v3)
        {
            return PointInTriangle(pt, v1, v2, v3) || PointInTriangle(pt, v2, v3, new Point(v3.X + (v2.X - v1.X), v3.Y + (v2.Y - v1.Y)));
        }
        public static bool PointInTriangle(Point pt, Point v1, Point v2, Point v3)
        {
            float d1, d2, d3;
            bool has_neg, has_pos;

            d1 = Sign(pt, v1, v2);
            d2 = Sign(pt, v2, v3);
            d3 = Sign(pt, v3, v1);

            has_neg = (d1 < 0) || (d2 < 0) || (d3 < 0);
            has_pos = (d1 > 0) || (d2 > 0) || (d3 > 0);

            return !(has_neg && has_pos);
        }
        public static float Sign(Point p1, Point p2, Point p3)
        {
            return (float)((p1.X - p3.X) * (p2.Y - p3.Y) - (p2.X - p3.X) * (p1.Y - p3.Y));
        }
    }
}
