﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using System.Xml.Serialization;

namespace GameCore
{
    public class TrafficScene
    {
        public static string BASEDIR = @"D:\DEV2021\Lesson4  - Finishing the MapMaker - PART1\";
        public static string MAPDIRECTORY = BASEDIR + "maps";

        public static string LOCATION_TILES = BASEDIR + @"Traffic\GameCore\images\tiles";
        public static string LOCATION_CARS = BASEDIR + @"Traffic\GameCore\images\\cars";
        public static string LOCATION_BUILDINGS = BASEDIR + @"Traffic\GameCore\images\buildings";
        public static string LOCATION_LIGHTS = BASEDIR + @"Traffic\GameCore\images\lights";

        public static string[] TILES = new[] {
            "gras",//0
            "asphalt",//1
            "concrete",//2
            "path",//3
            "pavement1", "pavement2", "pavement3", "pavement4",//7
            "pavementcorner1","pavementcorner2","pavementcorner3","pavementcorner4",//11
            "tilecorner1","tilecorner2","tilecorner3","tilecorner4",//15
            "tilepath1","tilepath2",//17
            "tilecross",//18
            "TileTSect1","TileTSect2","TileTSect3","TileTSect4",//22
            "pathcorner1","pathcorner2","pathcorner3","pathcorner4",//26
            "pathcross",//27
            "pathTSect1","pathTSect2","pathTSect3","pathTSect4",//31
            "pathway1","pathway2",//33
            "dirt1","dirt2","dirt3","dirt4","dirt5","dirt6",//39
            "dirtgrass1_1","dirtgrass1_2","dirtgrass1_3","dirtgrass1_4",//43
            "dirtgrass2_1","dirtgrass2_2","dirtgrass2_3","dirtgrass2_4",//47
            "dirtgrass3_1","dirtgrass3_2","dirtgrass3_3","dirtgrass3_4",//51
            "pedestriancrossing1", "pedestriancrossing2", //53
            "pedestriancrossingSmall1", "pedestriancrossingSmall2",//55
            "roundtiles",//56
            "dirt2path1", "dirt2path2",//58
            "dirt3path1", "dirt3path2",//60
            "dirt6path1", "dirt6path2",//62
            "dirt7","lava",//64
            "flower1_1","flower2_1",//66
            "flower3_1","flower4_1",//68
            "flower5_1","flower6_1",//70
            "smallstumps",//71
            "treestump1","treestump2",//73
            "lavacompact",//74
            "lavacorner1","lavacorner2","lavacorner3","lavacorner4",//78
            "lavafull1","lavafull2","lavafull3","lavafull4",//82
            "lavafullcorner1","lavafullcorner2","lavafullcorner3","lavafullcorner4",//86
            "lavaside1","lavaside2","lavaside3","lavaside4",//90
            "lavaside5","lavaside6","lavaside7","lavaside8",//94
            "lavaside9","lavaside10","lavaside11","lavaside12",//98
            "lavasmall1","lavasmall2",//100
            "lavastone1","lavastone2",//102
            "lavastone1path1","lavastone1path2",//104
            "lavastone2path1","lavastone2path2",//106
            "cornfield1_1","cornfield1_2","cornfield1_3","cornfield1_4",//110
            "colors"//111
        };
        public static string[] CARS = new[] {
            "BlackSedan1", "BlackSedan2", "BlackSedan3", "BlackSedan4",//3
            "BlueSedan1", "BlueSedan2","BlueSedan3","BlueSedan4",//7
            "CandySedan1", "CandySedan2","CandySedan3","CandySedan4",//11
            "GreenLorry1", "GreenLorry2","GreenLorry3","GreenLorry4",//15
            "GreenSedan1", "GreenSedan2","GreenSedan3","GreenSedan4",//19
            "PinkSedan1", "PinkSedan2","PinkSedan3","PinkSedan4",//23
            "WhiteSedan1", "WhiteSedan2","WhiteSedan3","WhiteSedan4",//27
            "YellowSedan1", "YellowSedan2","YellowSedan3","YellowSedan4",//31
            "BlueTruck1","BlueTruck2","BlueTruck3","BlueTruck4",//35
            "BrownTruck1","BrownTruck2","BrownTruck3","BrownTruck4",//39
            "GreenTruck1","GreenTruck2","GreenTruck3","GreenTruck4",//43
            "RedTruck1","RedTruck2","RedTruck3","RedTruck4",//47
            "BlueVan1_1","BlueVan1_2","BlueVan1_3","BlueVan1_4",//51
            "BlueVan2_1","BlueVan2_2","BlueVan2_3","BlueVan2_4",//55
            "BlueVan3_1","BlueVan3_2","BlueVan3_3","BlueVan3_4",//59
            "WhiteVan1_1","WhiteVan1_2","WhiteVan1_3","WhiteVan1_4",//63
            "WhiteVan2_1","WhiteVan2_2","WhiteVan2_3","WhiteVan2_4",//67
            "WhiteVan3_1","WhiteVan3_2","WhiteVan3_3","WhiteVan3_4",//71
            "SmartCarBlue1", "SmartCarBlue2","SmartCarBlue3","SmartCarBlue4",//75
            "SmartCarGreen1","SmartCarGreen2","SmartCarGreen3","SmartCarGreen4",//79
            "SmartCarOffWhite1","SmartCarOffWhite2","SmartCarOffWhite3","SmartCarOffWhite4",//83
            "SmartCarPaleGray1","SmartCarPaleGray2","SmartCarPaleGray3","SmartCarPaleGray4",//87
            "SmartCarPurple1","SmartCarPurple2","SmartCarPurple3","SmartCarPurple4",//91
            "SmartCarRed1","SmartCarRed2","SmartCarRed3","SmartCarRed4",//95
            "SmartCarYellow1","SmartCarYellow2","SmartCarYellow3","SmartCarYellow4",//99
            "RainbowVan1","RainbowVan2","RainbowVan3","RainbowVan4",//103
            "BlackHatch1","BlackHatch2","BlackHatch3","BlackHatch4",//107
            "BlackHatchRoof1","BlackHatchRoof2","BlackHatchRoof3","BlackHatchRoof4",//111
            "DarkblueHatch1","DarkblueHatch2","DarkblueHatch3","DarkblueHatch4",//115
            "DarkblueHatchRoof1","DarkblueHatchRoof2","DarkblueHatchRoof3","DarkblueHatchRoof4",//119
            "DarkdarkgrayHatch1","DarkdarkgrayHatch2","DarkdarkgrayHatch3","DarkdarkgrayHatch4",//123
            "DarkdarkgrayHatchRoof1","DarkdarkgrayHatchRoof2","DarkdarkgrayHatchRoof3","DarkdarkgrayHatchRoof4",//127
            "DarkgreenHatch1","DarkgreenHatch2","DarkgreenHatch3","DarkgreenHatch4",//131
            "DarkgreenHatchRoof1","DarkgreenHatchRoof2","DarkgreenHatchRoof3","DarkgreenHatchRoof4",//135
            "DarkredHatch1","DarkredHatch2","DarkredHatch3","DarkredHatch4",//139
            "DarkredHatchRoof1","DarkredHatchRoof2","DarkredHatchRoof3","DarkredHatchRoof4",//143
            "GrayHatch1","GrayHatch2","GrayHatch3","GrayHatch4",//147
            "GrayHatchRoof1","GrayHatchRoof2","GrayHatchRoof3","GrayHatchRoof4",//151
            "GreenHatch1","GreenHatch2","GreenHatch3","GreenHatch4",//155
            "GreenHatchRoof1","GreenHatchRoof2","GreenHatchRoof3","GreenHatchRoof4",//159
            "LightGrayHatch1","LightGrayHatch2","LightGrayHatch3","LightGrayHatch4",//163
            "LightGrayHatchRoof1","LightGrayHatchRoof2","LightGrayHatchRoof3","LightGrayHatchRoof4",//167
            "MedGrayHatch1","MedGrayHatch2","MedGrayHatch3","MedGrayHatch4",//171
            "MedGrayHatchRoof1","MedGrayHatchRoof2","MedGrayHatchRoof3","MedGrayHatchRoof4",//175
            "OrangeHatch1","OrangeHatch2","OrangeHatch3","OrangeHatch4",//179
            "OrangeHatchRoof1","OrangeHatchRoof2","OrangeHatchRoof3","OrangeHatchRoof4",//183
            "PaleBlueHatch1","PaleBlueHatch2","PaleBlueHatch3","PaleBlueHatch4",//187
            "PaleBlueHatchRoof1","PaleBlueHatchRoof2","PaleBlueHatchRoof3","PaleBlueHatchRoof4",//191
            "PaleWhiteHatch1","PaleWhiteHatch2","PaleWhiteHatch3","PaleWhiteHatch4",//195
            "PaleWhiteHatchRoof1","PaleWhiteHatchRoof2","PaleWhiteHatchRoof3","PaleWhiteHatchRoof4",//199
            "PurpleHatch1","PurpleHatch2","PurpleHatch3","PurpleHatch4",//203
            "PurpleHatchRoof1","PurpleHatchRoof2","PurpleHatchRoof3","PurpleHatchRoof4",//207
            "RedHatch1","RedHatch2","RedHatch3","RedHatch4",//211
            "RedHatchRoof1","RedHatchRoof2","RedHatchRoof3","RedHatchRoof4",//215
            "WhiteHatch1","WhiteHatch2","WhiteHatch3","WhiteHatch4",//219
            "YellowHatch1","YellowHatch2","YellowHatch3","YellowHatch4",//223
            "YellowHatchRoof1","YellowHatchRoof2","YellowHatchRoof3","YellowHatchRoof4",//227
            "TestVan1","TestVan2","TestVan3","TestVan4",
        };
        public static string[] BUILDINGS = new[] {
            //Buildings
            "BaracksA",  "BaracksB",//1
            "Factory1A", "Factory1B",//3
            "Factory2A", "Factory2B",//5
            "Factory3A", "Factory3B",//7
            "Finance1A", "Finance1B",//9
            "Finance2A", "Finance2B",//11
            "Finance3A", "Finance3B",//13
            "Office1A", "Office1B",//15
            "School1A", "School1B",//17
            "School2A", "School2B",//19
            "ThreeFloorAptsA", "ThreeFloorAptsB",//21
            "FiveFloorAptsA", "FiveFloorAptsB",//23
            "SixFloorAptsA", "SixFloorAptsB",//25
            "SevenFloorAptsA", "SevenFloorAptsB",//27
            "Tower1A", "Tower1B",//29
            "Tower2A", "Tower2B",//31
            "FireDeptA", "FireDeptB",//33
            "HospitalA", "HospitalB",//35
            "PoliceStationA", "PoliceStationB",//37
            //Nature
            "nature/SimpleBush1",//38
            "nature/SimpleTree1",//39
            "nature/SimpleTree2",//40
            "nature/Bush2A",@"nature/Bush2B",//42
            "nature/Bush3A",@"nature/Bush3B",//44
            "nature/Bush4A",@"nature/Bush4B",//46
            "nature/Bush5",//47
            "nature/Bush6",//48
            "nature/Bush7",//49
            "nature/Bush8",//50
            "nature/Bush9",//51
            "nature/Tree1",//52
            "nature/Tree2",//53
            "nature/Tree3",//54
            "nature/Tree4",//55
            "nature/Tree5",//56
            "nature/Tree6",//57
            "nature/Tree7",//58
            "nature/Tree8",//59
            "nature/Tree9",//60
            "nature/Tree10",//61
            "nature/Tree11",//62
            //Housing
            "Housing1A","Housing1B",//64
            "Housing2A","Housing2B",//66
            "Housing3A","Housing3B",//68
            "Housing4A","Housing4B",//70
            "Housing5A","Housing5B",//72
            "Housing6A","Housing6B",//74
            //Construction
            "construction/BarrierreA","construction/BarrierreB",//76
            "construction/BricksOnPalletA","construction/BricksOnPalletB",//78
            "construction/ConcreteBlockA","construction/ConcreteBlockB",//80
            "construction/ConcretePipeA","construction/ConcretePipeB",//82
            "construction/ConcreteRowA","construction/ConcreteRowB",//84
            "construction/ConcreteSlabsA","construction/ConcreteSlabsB",//86
            "construction/ConcreteSlabsStackedA","construction/ConcreteSlabsStackedB",//88
            "construction/ConstructionElementsA","construction/ConstructionElementsB",//90
            "construction/ConstructionElements2A","construction/ConstructionElements2B",//92
            "construction/PipesA","construction/PipesB",//94
            "construction/PipesPlasticA","construction/PipesPlasticB",//96
            "construction/PipesStackedA","construction/PipesStackedB",//98
            "construction/RoofPlatesStackedA","construction/RoofPlatesStackedB",//100
            "construction/SacksOnPalletA","construction/SacksOnPalletB",//102
            "construction/WoodPlanksStackedA","construction/WoodPlanksStackedB",//104
        };
        public static string[] LIGHTS = new[] {
            "CarGreenWalkRedA", "CarGreenWalkRedB",//1
            "CarRedWalkGreenA", "CarRedWalkGreenB",//3
            "CarYellowWalkRedA", "CarYellowWalkRedB",//5
            "BacksideA" , "BacksideB",//7
            "BacksideFrontCarGreenA", "BacksideFrontCarGreenB",//9
            "BacksideFrontCarRedA", "BacksideFrontCarRedB",//11
            "BacksideFrontCarYellowA", "BacksideFrontCarYellowB",//13
            "BacksideFrontGreenA", "BacksideFrontGreenB",//15
            "BacksideFrontRedA", "BacksideFrontRedB",//17
            "Light1A", "Light1B","Light1C","Light1D",//21
            "Light2A", "Light2B","Light2C","Light2D",//25
            "Light3A", "Light3B","Light3C","Light3D",//29
            "Light4A", "Light4B","Light4C","Light4D",//33
            "Light5A", "Light5B","Light5C","Light5D",//37
            "Light6A", "Light6B","Light6C","Light6D",//41
            "Light7A", "Light7B","Light7C","Light7D",//45
            "Light8A", "Light8B","Light8C","Light8D",//49
            "Light9A", "Light9B","Light9C","Light9D",//53
            "Light10A", "Light10B","Light10C","Light10D",//57
            "Light11A", "Light11B","Light11C","Light11D",//61
            "Light12A", "Light12B",//63
        };

        public static List<TileTemplate> DESIGNTEMPLATES_TILES = new List<TileTemplate> {
            new TileTemplate {Name = "Grass", Type = TemplateType.Tile, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = 0, ImageIndexSW = 0, ImageIndexNW = 0},
            new TileTemplate {Name = "Asphalt",  Type = TemplateType.Tile, ImageIndex = 1, ImageIndexSE = 1, ImageIndexNE = 1, ImageIndexSW = 1, ImageIndexNW = 1},
            new TileTemplate {Name = "Concrete",  Type = TemplateType.Tile, ImageIndex = 2, ImageIndexSE = 2, ImageIndexNE = 2, ImageIndexSW = 2, ImageIndexNW = 2},
            new TileTemplate {Name = "Path",  Type = TemplateType.Tile, ImageIndex = 3, ImageIndexSE = 3, ImageIndexNE = 3, ImageIndexSW = 3, ImageIndexNW = 3},
            new TileTemplate {Name = "Pavement",  Type = TemplateType.Tile, ImageIndex = 4, ImageIndexSE = 4, ImageIndexNE = 5, ImageIndexSW = 6, ImageIndexNW = 7},
            new TileTemplate {Name = "Pavement Corner",  Type = TemplateType.Tile, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = 9, ImageIndexSW = 10, ImageIndexNW = 11},
            new TileTemplate {Name = "Tile Corner",  Type = TemplateType.Tile, ImageIndex = 12, ImageIndexSE = 12, ImageIndexNE = 13, ImageIndexSW = 14, ImageIndexNW = 15},
            new TileTemplate {Name = "Tile Path",  Type = TemplateType.Tile, ImageIndex = 16, ImageIndexSE = 16, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 17},
            new TileTemplate {Name = "Tile Cross",  Type = TemplateType.Tile, ImageIndex = 18, ImageIndexSE = 18, ImageIndexNE = 18, ImageIndexSW = 18, ImageIndexNW = 18},
            new TileTemplate {Name = "Tile T-Section",  Type = TemplateType.Tile, ImageIndex = 19, ImageIndexSE = 19, ImageIndexNE = 20, ImageIndexSW = 21, ImageIndexNW = 22},
            new TileTemplate {Name = "Path Corner",  Type = TemplateType.Tile, ImageIndex = 23, ImageIndexSE = 23, ImageIndexNE = 24, ImageIndexSW = 25, ImageIndexNW = 26},
            new TileTemplate {Name = "Path Cross",  Type = TemplateType.Tile, ImageIndex = 27, ImageIndexSE = 27, ImageIndexNE = 27, ImageIndexSW = 27, ImageIndexNW = 27},
            new TileTemplate {Name = "Path T-Section",  Type = TemplateType.Tile, ImageIndex = 28, ImageIndexSE = 28, ImageIndexNE = 29, ImageIndexSW = 30, ImageIndexNW = 31},
            new TileTemplate {Name = "Dirt Path",  Type = TemplateType.Tile, ImageIndex = 32, ImageIndexSE = 32, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 33},
            new TileTemplate {Name = "Dirt 1", Type = TemplateType.Tile, ImageIndex = 34, ImageIndexSE = 34, ImageIndexNE = 34, ImageIndexSW = 34, ImageIndexNW = 34},
            new TileTemplate {Name = "Dirt 2", Type = TemplateType.Tile, ImageIndex = 35, ImageIndexSE = 35, ImageIndexNE = 35, ImageIndexSW = 35, ImageIndexNW = 35},
            new TileTemplate {Name = "Dirt 3", Type = TemplateType.Tile, ImageIndex = 36, ImageIndexSE = 36, ImageIndexNE = 36, ImageIndexSW = 36, ImageIndexNW = 36},
            new TileTemplate {Name = "Dirt 4", Type = TemplateType.Tile, ImageIndex = 37, ImageIndexSE = 37, ImageIndexNE = 37, ImageIndexSW = 37, ImageIndexNW = 37},
            new TileTemplate {Name = "Dirt 5", Type = TemplateType.Tile, ImageIndex = 38, ImageIndexSE = 38, ImageIndexNE = 38, ImageIndexSW = 38, ImageIndexNW = 38},
            new TileTemplate {Name = "Dirt 6", Type = TemplateType.Tile, ImageIndex = 39, ImageIndexSE = 39, ImageIndexNE = 39, ImageIndexSW = 39, ImageIndexNW = 39},
            new TileTemplate {Name = "Dirt Grass 1", Type = TemplateType.Tile, ImageIndex = 40, ImageIndexSE = 40, ImageIndexNE = 41, ImageIndexSW = 42, ImageIndexNW = 43},
            new TileTemplate {Name = "Dirt Grass 2", Type = TemplateType.Tile, ImageIndex = 44, ImageIndexSE = 44, ImageIndexNE = 45, ImageIndexSW = 46, ImageIndexNW = 47},
            new TileTemplate {Name = "Dirt Grass 3", Type = TemplateType.Tile, ImageIndex = 48, ImageIndexSE = 48, ImageIndexNE = 49, ImageIndexSW = 50, ImageIndexNW = 51},
            new TileTemplate {Name = "Pedestrian Crossing",  Type = TemplateType.Tile, ImageIndex = 52, ImageIndexSE = 52, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 53},
            new TileTemplate {Name = "Pedestrian Crossing Small",  Type = TemplateType.Tile, ImageIndex = 54, ImageIndexSE = 54, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 55},
            new TileTemplate {Name = "Round Tile",  Type = TemplateType.Tile, ImageIndex = 56, ImageIndexSE = 56, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 56},
            new TileTemplate {Name = "Dirt 2 path", Type = TemplateType.Tile, ImageIndex = 57, ImageIndexSE = 57, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 58},
            new TileTemplate {Name = "Dirt 3 path", Type = TemplateType.Tile, ImageIndex = 59, ImageIndexSE = 59, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 60},
            new TileTemplate {Name = "Dirt 6 path", Type = TemplateType.Tile, ImageIndex = 61, ImageIndexSE = 61, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 62},

            new TileTemplate {Name = "Dirt 7", Type = TemplateType.Tile, ImageIndex = 63, ImageIndexSE = 63, ImageIndexNE = 63, ImageIndexSW = 63, ImageIndexNW = 63},
            new TileTemplate {Name = "Lava", Type = TemplateType.Tile, ImageIndex = 64, ImageIndexSE = 64, ImageIndexNE = 64, ImageIndexSW = 64, ImageIndexNW = 64},
            new TileTemplate {Name = "Flower 1", Type = TemplateType.Tile, ImageIndex = 65, ImageIndexSE = 65, ImageIndexNE = 65, ImageIndexSW = 65, ImageIndexNW = 65},
            new TileTemplate {Name = "Flower 2", Type = TemplateType.Tile, ImageIndex = 66, ImageIndexSE = 66, ImageIndexNE = 66, ImageIndexSW = 66, ImageIndexNW = 66},
            new TileTemplate {Name = "Flower 3", Type = TemplateType.Tile, ImageIndex = 67, ImageIndexSE = 67, ImageIndexNE = 67, ImageIndexSW = 67, ImageIndexNW = 67},
            new TileTemplate {Name = "Flower 4", Type = TemplateType.Tile, ImageIndex = 68, ImageIndexSE = 68, ImageIndexNE = 68, ImageIndexSW = 68, ImageIndexNW = 68},
            new TileTemplate {Name = "Flower 5", Type = TemplateType.Tile, ImageIndex = 69, ImageIndexSE = 69, ImageIndexNE = 69, ImageIndexSW = 69, ImageIndexNW = 69},
            new TileTemplate {Name = "Flower 6", Type = TemplateType.Tile, ImageIndex = 70, ImageIndexSE = 70, ImageIndexNE = 70, ImageIndexSW = 70, ImageIndexNW = 70},
            new TileTemplate {Name = "SmallStumps", Type = TemplateType.Tile, ImageIndex = 71, ImageIndexSE = 71, ImageIndexNE = 71, ImageIndexSW = 71, ImageIndexNW = 71},
            new TileTemplate {Name = "Tree Stump", Type = TemplateType.Tile, ImageIndex = 72, ImageIndexSE = 72, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 73},
};
        public static List<TileTemplate> DESIGNTEMPLATES_CARS = new List<TileTemplate> {
            new TileTemplate {Name = "Black Sedan", Type = TemplateType.Car, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = 1, ImageIndexSW = 2, ImageIndexNW = 3},
            new TileTemplate {Name = "Blue Sedan", Type = TemplateType.Car, ImageIndex = 4, ImageIndexSE = 4, ImageIndexNE = 5, ImageIndexSW = 6, ImageIndexNW = 7},
            new TileTemplate {Name = "Candy Sedan", Type = TemplateType.Car, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = 9, ImageIndexSW = 10, ImageIndexNW = 11},
            new TileTemplate {Name = "Green Lorry", Type = TemplateType.Car, ImageIndex = 12, ImageIndexSE = 12, ImageIndexNE = 13, ImageIndexSW = 14, ImageIndexNW = 15},
            new TileTemplate {Name = "Green Sedan", Type = TemplateType.Car, ImageIndex = 16, ImageIndexSE = 16, ImageIndexNE = 17, ImageIndexSW = 18, ImageIndexNW = 19},
            new TileTemplate {Name = "Pink Sedan", Type = TemplateType.Car, ImageIndex = 20, ImageIndexSE = 20, ImageIndexNE = 21, ImageIndexSW = 22, ImageIndexNW = 23},
            new TileTemplate {Name = "White Sedan", Type = TemplateType.Car, ImageIndex = 24, ImageIndexSE = 24, ImageIndexNE = 25, ImageIndexSW = 26, ImageIndexNW = 27},
            new TileTemplate {Name = "Yellow Sedan", Type = TemplateType.Car, ImageIndex = 28, ImageIndexSE = 28, ImageIndexNE = 29, ImageIndexSW = 30, ImageIndexNW = 31},
            new TileTemplate {Name = "Blue Truck", Type = TemplateType.Car, ImageIndex = 32, ImageIndexSE = 32, ImageIndexNE = 33, ImageIndexSW = 34, ImageIndexNW = 35},
            new TileTemplate {Name = "Brown Truck", Type = TemplateType.Car, ImageIndex = 36, ImageIndexSE = 36, ImageIndexNE = 37, ImageIndexSW = 38, ImageIndexNW = 39},
            new TileTemplate {Name = "Green Truck", Type = TemplateType.Car, ImageIndex = 40, ImageIndexSE = 40, ImageIndexNE = 41, ImageIndexSW = 42, ImageIndexNW = 43},
            new TileTemplate {Name = "Red Truck", Type = TemplateType.Car, ImageIndex = 44, ImageIndexSE = 44, ImageIndexNE = 45, ImageIndexSW = 46, ImageIndexNW = 47},
            new TileTemplate {Name = "Blue Van1", Type = TemplateType.Car, ImageIndex = 48, ImageIndexSE = 48, ImageIndexNE = 49, ImageIndexSW = 50, ImageIndexNW = 51},
            new TileTemplate {Name = "Blue Van2", Type = TemplateType.Car, ImageIndex = 52, ImageIndexSE = 52, ImageIndexNE = 53, ImageIndexSW = 54, ImageIndexNW = 55},
            new TileTemplate {Name = "Blue Van3", Type = TemplateType.Car, ImageIndex = 56, ImageIndexSE = 56, ImageIndexNE = 57, ImageIndexSW = 58, ImageIndexNW = 59},
            new TileTemplate {Name = "White Van1", Type = TemplateType.Car, ImageIndex = 60, ImageIndexSE = 60, ImageIndexNE = 61, ImageIndexSW = 62, ImageIndexNW = 63},
            new TileTemplate {Name = "White Van2", Type = TemplateType.Car, ImageIndex = 64, ImageIndexSE = 64, ImageIndexNE = 65, ImageIndexSW = 66, ImageIndexNW = 67},
            new TileTemplate {Name = "White Van3", Type = TemplateType.Car, ImageIndex = 68, ImageIndexSE = 68, ImageIndexNE = 69, ImageIndexSW = 70, ImageIndexNW = 71},
            new TileTemplate {Name = "Blue Smartcar", Type = TemplateType.Car, ImageIndex = 72, ImageIndexSE = 72, ImageIndexNE = 73, ImageIndexSW = 74, ImageIndexNW = 75},
            new TileTemplate {Name = "Green Smartcar", Type = TemplateType.Car, ImageIndex = 76, ImageIndexSE = 76, ImageIndexNE = 77, ImageIndexSW = 78, ImageIndexNW = 79},
            new TileTemplate {Name = "Offwhite Smartcar", Type = TemplateType.Car, ImageIndex = 80, ImageIndexSE = 80, ImageIndexNE = 81, ImageIndexSW = 82, ImageIndexNW = 83},
            new TileTemplate {Name = "Palegray Smartcar", Type = TemplateType.Car, ImageIndex = 84, ImageIndexSE = 84, ImageIndexNE = 85, ImageIndexSW = 86, ImageIndexNW = 87},
            new TileTemplate {Name = "Purple Smartcar", Type = TemplateType.Car, ImageIndex = 88, ImageIndexSE = 88, ImageIndexNE = 89, ImageIndexSW = 90, ImageIndexNW = 91},
            new TileTemplate {Name = "Red Smartcar", Type = TemplateType.Car, ImageIndex = 92, ImageIndexSE = 92, ImageIndexNE = 93, ImageIndexSW = 94, ImageIndexNW = 95},
            new TileTemplate {Name = "Yellow Smartcar", Type = TemplateType.Car, ImageIndex = 96, ImageIndexSE = 96, ImageIndexNE = 97, ImageIndexSW = 98, ImageIndexNW = 99},
            new TileTemplate {Name = "Rainbow Van", Type = TemplateType.Car, ImageIndex = 100, ImageIndexSE = 100, ImageIndexNE = 101, ImageIndexSW = 102, ImageIndexNW = 103},
            new TileTemplate {Name = "Black Hatchback", Type = TemplateType.Car, ImageIndex = 104, ImageIndexSE = 104, ImageIndexNE = 105, ImageIndexSW = 106, ImageIndexNW = 107},
            new TileTemplate {Name = "Black Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 108, ImageIndexSE = 108, ImageIndexNE = 109, ImageIndexSW = 110, ImageIndexNW = 111},
            new TileTemplate {Name = "Darkblue Hatchback", Type = TemplateType.Car, ImageIndex = 112, ImageIndexSE = 112, ImageIndexNE = 113, ImageIndexSW = 114, ImageIndexNW = 115},
            new TileTemplate {Name = "Darkblue Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 116, ImageIndexSE = 116, ImageIndexNE = 117, ImageIndexSW = 118, ImageIndexNW = 119},
            new TileTemplate {Name = "Darkgray Hatchback", Type = TemplateType.Car, ImageIndex = 120, ImageIndexSE = 120, ImageIndexNE = 121, ImageIndexSW = 122, ImageIndexNW = 123},
            new TileTemplate {Name = "Darkgray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 124, ImageIndexSE = 124, ImageIndexNE = 125, ImageIndexSW = 126, ImageIndexNW = 127},
            new TileTemplate {Name = "Darkgreen Hatchback", Type = TemplateType.Car, ImageIndex = 128, ImageIndexSE = 128, ImageIndexNE = 129, ImageIndexSW = 130, ImageIndexNW = 131},
            new TileTemplate {Name = "Darkgreen Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 132, ImageIndexSE = 132, ImageIndexNE = 133, ImageIndexSW = 134, ImageIndexNW = 135},
            new TileTemplate {Name = "Darkred Hatchback", Type = TemplateType.Car, ImageIndex = 136, ImageIndexSE = 136, ImageIndexNE = 137, ImageIndexSW = 138, ImageIndexNW = 139},
            new TileTemplate {Name = "Darkred Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 140, ImageIndexSE = 140, ImageIndexNE = 141, ImageIndexSW = 142, ImageIndexNW = 143},
            new TileTemplate {Name = "Gray Hatchback", Type = TemplateType.Car, ImageIndex = 144, ImageIndexSE = 144, ImageIndexNE = 145, ImageIndexSW = 146, ImageIndexNW = 147},
            new TileTemplate {Name = "Gray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 148, ImageIndexSE = 148, ImageIndexNE = 149, ImageIndexSW = 150, ImageIndexNW = 151},
            new TileTemplate {Name = "Green Hatchback", Type = TemplateType.Car, ImageIndex = 152, ImageIndexSE = 152, ImageIndexNE = 153, ImageIndexSW = 154, ImageIndexNW = 155},
            new TileTemplate {Name = "Green Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 156, ImageIndexSE = 156, ImageIndexNE = 157, ImageIndexSW = 158, ImageIndexNW = 159},
            new TileTemplate {Name = "Lightgray Hatchback", Type = TemplateType.Car, ImageIndex = 160, ImageIndexSE = 160, ImageIndexNE = 161, ImageIndexSW = 162, ImageIndexNW = 163},
            new TileTemplate {Name = "Lightgray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 164, ImageIndexSE = 164, ImageIndexNE = 165, ImageIndexSW = 166, ImageIndexNW = 167},
            new TileTemplate {Name = "Mediumgray Hatchback", Type = TemplateType.Car, ImageIndex = 168, ImageIndexSE = 168, ImageIndexNE = 169, ImageIndexSW = 170, ImageIndexNW = 171},
            new TileTemplate {Name = "Mediumgray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 172, ImageIndexSE = 172, ImageIndexNE = 173, ImageIndexSW = 174, ImageIndexNW = 175},
            new TileTemplate {Name = "Orange Hatchback", Type = TemplateType.Car, ImageIndex = 176, ImageIndexSE = 176, ImageIndexNE = 177, ImageIndexSW = 178, ImageIndexNW = 179},
            new TileTemplate {Name = "Orange Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 180, ImageIndexSE = 180, ImageIndexNE = 181, ImageIndexSW = 182, ImageIndexNW = 183},
            new TileTemplate {Name = "Paleblue Hatchback", Type = TemplateType.Car, ImageIndex = 184, ImageIndexSE = 184, ImageIndexNE = 185, ImageIndexSW = 186, ImageIndexNW = 187},
            new TileTemplate {Name = "Paleblue Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 188, ImageIndexSE = 188, ImageIndexNE = 189, ImageIndexSW = 190, ImageIndexNW = 191},
            new TileTemplate {Name = "Palewhite Hatchback", Type = TemplateType.Car, ImageIndex = 192, ImageIndexSE = 192, ImageIndexNE = 193, ImageIndexSW = 194, ImageIndexNW = 195},
            new TileTemplate {Name = "Palewhite Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 196, ImageIndexSE = 196, ImageIndexNE = 197, ImageIndexSW = 198, ImageIndexNW = 199},
            new TileTemplate {Name = "Purple Hatchback", Type = TemplateType.Car, ImageIndex = 200, ImageIndexSE = 200, ImageIndexNE = 201, ImageIndexSW = 202, ImageIndexNW = 203},
            new TileTemplate {Name = "Purple Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 204, ImageIndexSE = 204, ImageIndexNE = 205, ImageIndexSW = 206, ImageIndexNW = 207},
            new TileTemplate {Name = "Red Hatchback", Type = TemplateType.Car, ImageIndex = 208, ImageIndexSE = 209, ImageIndexNE = 210, ImageIndexSW = 211, ImageIndexNW = 212},
            new TileTemplate {Name = "Red Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 212, ImageIndexSE = 212, ImageIndexNE = 213, ImageIndexSW = 214, ImageIndexNW = 215},
            new TileTemplate {Name = "White Hatchback", Type = TemplateType.Car, ImageIndex = 216, ImageIndexSE = 216, ImageIndexNE = 217, ImageIndexSW = 218, ImageIndexNW = 219},
            new TileTemplate {Name = "Yellow Hatchback", Type = TemplateType.Car, ImageIndex = 220, ImageIndexSE = 220, ImageIndexNE = 221, ImageIndexSW = 222, ImageIndexNW = 223},
            new TileTemplate {Name = "Yellow Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 224, ImageIndexSE = 224, ImageIndexNE = 225, ImageIndexSW = 226, ImageIndexNW = 227},
            new TileTemplate {Name = "White Test Van", Type = TemplateType.Car, ImageIndex = 228, ImageIndexSE = 228, ImageIndexNE = 229, ImageIndexSW = 230, ImageIndexNW = 231},
        };
        public static List<TileTemplate> DESIGNTEMPLATES_BUILDINGS = new List<TileTemplate> {
            //Buildings
            new TileTemplate {Name = "Baracks", Type = TemplateType.ModernBuilding, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 1},
            new TileTemplate {Name = "Factory 1", Type = TemplateType.ModernBuilding, ImageIndex = 2, ImageIndexSE = 2, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 3},
            new TileTemplate {Name = "Factory 2", Type = TemplateType.ModernBuilding, ImageIndex = 4, ImageIndexSE = 4, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 5},
            new TileTemplate {Name = "Factory 3", Type = TemplateType.ModernBuilding, ImageIndex = 6, ImageIndexSE = 6, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 7},
            new TileTemplate {Name = "Finance 1", Type = TemplateType.ModernBuilding, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 9},
            new TileTemplate {Name = "Finance 2", Type = TemplateType.ModernBuilding, ImageIndex = 10, ImageIndexSE = 10, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 11},
            new TileTemplate {Name = "Finance 3", Type = TemplateType.ModernBuilding, ImageIndex = 12, ImageIndexSE = 12, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 13},
            new TileTemplate {Name = "Office", Type = TemplateType.ModernBuilding, ImageIndex = 14, ImageIndexSE = 14, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 15},
            new TileTemplate {Name = "School 1", Type = TemplateType.ModernBuilding, ImageIndex = 16, ImageIndexSE = 16, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 17},
            new TileTemplate {Name = "School 2", Type = TemplateType.ModernBuilding, ImageIndex = 18, ImageIndexSE = 18, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 19},
            new TileTemplate {Name = "Apts 3 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 20, ImageIndexSE = 20, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 21},
            new TileTemplate {Name = "Apts 5 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 22, ImageIndexSE = 22, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 23},
            new TileTemplate {Name = "Apts 6 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 24, ImageIndexSE = 24, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 25},
            new TileTemplate {Name = "Apts 7 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 26, ImageIndexSE = 26, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 27},
            new TileTemplate {Name = "Tower 1", Type = TemplateType.ModernBuilding, ImageIndex = 28, ImageIndexSE = 28, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 29},
            new TileTemplate {Name = "Tower 2", Type = TemplateType.ModernBuilding, ImageIndex = 30, ImageIndexSE = 30, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 31},
            new TileTemplate {Name = "Fire Department", Type = TemplateType.ModernBuilding, ImageIndex = 32, ImageIndexSE = 32, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 43},
            new TileTemplate {Name = "Hospital", Type = TemplateType.ModernBuilding, ImageIndex = 34, ImageIndexSE = 34, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 35},
            new TileTemplate {Name = "Police Station", Type = TemplateType.ModernBuilding, ImageIndex = 36, ImageIndexSE = 36, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 37},
            //Nature
            new TileTemplate {Name = "Bush Simple", Type = TemplateType.Nature, ImageIndex = 38, ImageIndexSE = 38, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 38},
            new TileTemplate {Name = "Tree Simple 1", Type = TemplateType.Nature, ImageIndex = 39, ImageIndexSE = 39, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 39},
            new TileTemplate {Name = "Tree Simple 2", Type = TemplateType.Nature, ImageIndex = 40, ImageIndexSE = 40, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 40},
            new TileTemplate {Name = "Bush 2", Type = TemplateType.Nature, ImageIndex = 41, ImageIndexSE = 41, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 42},
            new TileTemplate {Name = "Bush 3", Type = TemplateType.Nature, ImageIndex = 43, ImageIndexSE = 43, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 44},
            new TileTemplate {Name = "Bush 4", Type = TemplateType.Nature, ImageIndex = 45, ImageIndexSE = 45, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 46},
            new TileTemplate {Name = "Bush 5", Type = TemplateType.Nature, ImageIndex = 47, ImageIndexSE = 47, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 47},
            new TileTemplate {Name = "Bush 6", Type = TemplateType.Nature, ImageIndex = 48, ImageIndexSE = 48, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 48},
            new TileTemplate {Name = "Bush 7", Type = TemplateType.Nature, ImageIndex = 49, ImageIndexSE = 49, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 49},
            new TileTemplate {Name = "Bush 8", Type = TemplateType.Nature, ImageIndex = 50, ImageIndexSE = 50, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 50},
            new TileTemplate {Name = "Bush 9", Type = TemplateType.Nature, ImageIndex = 51, ImageIndexSE = 51, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 51},
            new TileTemplate {Name = "Tree 1", Type = TemplateType.Nature, ImageIndex = 52, ImageIndexSE = 52, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 52},
            new TileTemplate {Name = "Tree 2", Type = TemplateType.Nature, ImageIndex = 53, ImageIndexSE = 53, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 53},
            new TileTemplate {Name = "Tree 3", Type = TemplateType.Nature, ImageIndex = 54, ImageIndexSE = 54, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 54},
            new TileTemplate {Name = "Tree 4", Type = TemplateType.Nature, ImageIndex = 55, ImageIndexSE = 55, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 55},
            new TileTemplate {Name = "Tree 5", Type = TemplateType.Nature, ImageIndex = 56, ImageIndexSE = 56, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 56},
            new TileTemplate {Name = "Tree 6", Type = TemplateType.Nature, ImageIndex = 57, ImageIndexSE = 57, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 57},
            new TileTemplate {Name = "Tree 7", Type = TemplateType.Nature, ImageIndex = 58, ImageIndexSE = 58, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 58},
            new TileTemplate {Name = "Tree 8", Type = TemplateType.Nature, ImageIndex = 59, ImageIndexSE = 59, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 59},
            new TileTemplate {Name = "Tree 9", Type = TemplateType.Nature, ImageIndex = 60, ImageIndexSE = 60, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 60},
            new TileTemplate {Name = "Tree 10", Type = TemplateType.Nature, ImageIndex = 61, ImageIndexSE = 61, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 61},
            new TileTemplate {Name = "Tree 11", Type = TemplateType.Nature, ImageIndex = 62, ImageIndexSE = 62, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 62},
            //Housing
            new TileTemplate {Name = "Housing 1", Type = TemplateType.ModernBuilding, ImageIndex = 63, ImageIndexSE = 63, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 64},
            new TileTemplate {Name = "Housing 2", Type = TemplateType.ModernBuilding, ImageIndex = 65, ImageIndexSE = 65, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 66},
            new TileTemplate {Name = "Housing 3", Type = TemplateType.ModernBuilding, ImageIndex = 67, ImageIndexSE = 67, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 68},
            new TileTemplate {Name = "Housing 4", Type = TemplateType.ModernBuilding, ImageIndex = 69, ImageIndexSE = 69, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 70},
            new TileTemplate {Name = "Housing 5", Type = TemplateType.ModernBuilding, ImageIndex = 71, ImageIndexSE = 71, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 72},
            new TileTemplate {Name = "Housing 6", Type = TemplateType.ModernBuilding, ImageIndex = 73, ImageIndexSE = 73, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 74},
            //Construction
            new TileTemplate {Name = "Barrier", Type = TemplateType.Construction, ImageIndex = 75, ImageIndexSE = 75, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 76},
            new TileTemplate {Name = "Bricks On Pallet", Type = TemplateType.Construction, ImageIndex = 77, ImageIndexSE = 77, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 78},
            new TileTemplate {Name = "Concrete Block", Type = TemplateType.Construction, ImageIndex = 79, ImageIndexSE = 79, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 80},
            new TileTemplate {Name = "Concrete Pipe", Type = TemplateType.Construction, ImageIndex = 81, ImageIndexSE = 81, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 82},
            new TileTemplate {Name = "Concrete Row", Type = TemplateType.Construction, ImageIndex = 83, ImageIndexSE = 83, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 84},
            new TileTemplate {Name = "Concrete Slabs", Type = TemplateType.Construction, ImageIndex = 85, ImageIndexSE = 85, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 86},
            new TileTemplate {Name = "Concrete Slabs Stacked", Type = TemplateType.Construction, ImageIndex = 87, ImageIndexSE = 87, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 88},
            new TileTemplate {Name = "Construction Elements", Type = TemplateType.Construction, ImageIndex = 89, ImageIndexSE = 89, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 90},
            new TileTemplate {Name = "Construction Elements 2", Type = TemplateType.Construction, ImageIndex = 91, ImageIndexSE = 91, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 92},
            new TileTemplate {Name = "Pipes", Type = TemplateType.Construction, ImageIndex = 93, ImageIndexSE = 93, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 94},
            new TileTemplate {Name = "Pipes Plastic", Type = TemplateType.Construction, ImageIndex = 95, ImageIndexSE = 95, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 96},
            new TileTemplate {Name = "Pipes Stacked", Type = TemplateType.Construction, ImageIndex = 97, ImageIndexSE = 97, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 98},
            new TileTemplate {Name = "Roof Plates Stacked", Type = TemplateType.Construction, ImageIndex = 99, ImageIndexSE = 99, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 100},
            new TileTemplate {Name = "Sacks On Pallet", Type = TemplateType.Construction, ImageIndex = 101, ImageIndexSE = 101, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 102},
            new TileTemplate {Name = "Wood Planks Stacked", Type = TemplateType.Construction, ImageIndex = 103, ImageIndexSE = 103, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 104},
        };
        public static List<TileTemplate> DESIGNTEMPLATES_LIGHTS = new List<TileTemplate> {
            new TileTemplate {Name = "Frontside Car & Walk", Type = TemplateType.LightFront, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 1},
            new TileTemplate {Name = "Backside Car & Walk", Type = TemplateType.LightBack, ImageIndex = 6, ImageIndexSE = 6, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 7},
            new TileTemplate {Name = "Frontside Car & backside Walk", Type = TemplateType.LightFront, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 9},
            new TileTemplate {Name = "Backside Car & frontside Walk 1", Type = TemplateType.LightFront, ImageIndex = 14, ImageIndexSE = 14, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 15},
            new TileTemplate {Name = "Backside Car & frontside Walk 2", Type = TemplateType.LightFront, ImageIndex = 16, ImageIndexSE = 14, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 17},

            new TileTemplate {Name = "Light 1", Type = TemplateType.StaticLight, ImageIndex = 18, ImageIndexSE = 18, ImageIndexNE = 19, ImageIndexSW = 20, ImageIndexNW = 21},
            new TileTemplate {Name = "Light 2", Type = TemplateType.StaticLight, ImageIndex = 22, ImageIndexSE = 22, ImageIndexNE = 23, ImageIndexSW = 24, ImageIndexNW = 25},
            new TileTemplate {Name = "Light 3", Type = TemplateType.StaticLight, ImageIndex = 26, ImageIndexSE = 26, ImageIndexNE = 27, ImageIndexSW = 28, ImageIndexNW = 29},
            new TileTemplate {Name = "Light 4", Type = TemplateType.StaticLight, ImageIndex = 30, ImageIndexSE = 30, ImageIndexNE = 31, ImageIndexSW = 32, ImageIndexNW = 33},
            new TileTemplate {Name = "Light 5", Type = TemplateType.StaticLight, ImageIndex = 34, ImageIndexSE = 34, ImageIndexNE = 35, ImageIndexSW = 36, ImageIndexNW = 37},
            new TileTemplate {Name = "Light 6", Type = TemplateType.StaticLight, ImageIndex = 38, ImageIndexSE = 38, ImageIndexNE = 39, ImageIndexSW = 40, ImageIndexNW = 41},
            new TileTemplate {Name = "Light 7", Type = TemplateType.StaticLight, ImageIndex = 42, ImageIndexSE = 42, ImageIndexNE = 43, ImageIndexSW = 44, ImageIndexNW = 45},
            new TileTemplate {Name = "Light 8", Type = TemplateType.StaticLight, ImageIndex = 46, ImageIndexSE = 46, ImageIndexNE = 47, ImageIndexSW = 48, ImageIndexNW = 49},
            new TileTemplate {Name = "Light 9", Type = TemplateType.StaticLight, ImageIndex = 50, ImageIndexSE = 50, ImageIndexNE = 51, ImageIndexSW = 52, ImageIndexNW = 53},
            new TileTemplate {Name = "Light 10", Type = TemplateType.StaticLight, ImageIndex = 54, ImageIndexSE = 54, ImageIndexNE = 55, ImageIndexSW = 56, ImageIndexNW = 57},
            new TileTemplate {Name = "Light 11", Type = TemplateType.StaticLight, ImageIndex = 58, ImageIndexSE = 58, ImageIndexNE = 59, ImageIndexSW = 60, ImageIndexNW = 61},
            new TileTemplate {Name = "Light 12", Type = TemplateType.StaticLight, ImageIndex = 62, ImageIndexSE = 62, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 63},

        };
        public static Map LoadMap(string filename)
        {
            try
            {
                Map map = new Map();
                using (Stream stream = File.Open(filename, FileMode.Open))
                {
                    IFormatter formatter = new BinaryFormatter();
                    map = (Map)formatter.Deserialize(stream);
                }
                return map;
            }
            catch
            {
                MessageBox.Show("Failed to load map", "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                //Debug.WriteLine("Failed to load map");
                return null;
            }
        }
        public static void SaveMap(string filename, Map map)
        {
            try
            {
                using Stream stream = File.Open(filename, FileMode.Create);
                IFormatter formatter = new BinaryFormatter();
                formatter.Serialize(stream, map);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Failed to save map: " + ex.Message, "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                //Debug.WriteLine("Failed to save map");                
                return;
            }
        }
        public static Map LoadMapXML(string filename)
        {
            try
            {
                Map map = new Map();
                using (System.IO.Stream stream = System.IO.File.Open(filename, System.IO.FileMode.Open))
                {
                    var serializer = new XmlSerializer(typeof(Map));
                    map = (Map)serializer.Deserialize(stream);
                }
                return map;
            }
            catch (Exception)
            {
                MessageBox.Show("Failed to load map", "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        public static void SaveMapXML(string filename, Map map)
        {
            try
            {
                using System.IO.Stream stream = System.IO.File.Open(filename, System.IO.FileMode.Create);
                var serializer = new XmlSerializer(typeof(Map));
                serializer.Serialize(stream, map);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Failed to save map: " + ex.Message, "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                return;
            }
        }
        public static void DrawMap(Map map, Canvas canvas, bool drawCars, bool drawBuildings, bool drawLights)
        {
            canvas.Children.Clear();
            int mapWidth = map.TileMap.GetLength(0);
            int mapHeight = map.TileMap.GetLength(1);
            canvas.Width = (mapWidth + .5) * map.TileWidth;
            canvas.Height = (mapHeight + 1) * (map.TileHeight / 2);
            //First draw core tiles
            for (int y = 0; y < mapHeight; y++)
            {
                for (int x = 0; x < mapWidth; x++)
                {
                    try
                    {
                        var tile = map.TileMap[x, y];
                        var img = DrawTile(canvas, tile, map.TileWidth, map.TileHeight);
                        //Groundtiles have no opacity property so we reuse it, if there is already an image attached, otherwise we would have to render the entire map again
                        if (tile.CurrentImage != null)
                            img.Opacity = tile.CurrentImage.Opacity;
                        tile.CurrentImage = img;
                    }
                    catch (Exception)
                    {
                        string fileName = string.Format("{0}\\{1}", LOCATION_TILES, "missing.png");
                        DrawTileFromResource(canvas, x, y, map.TileWidth, map.TileHeight, fileName);//create a special image for missing
                    }
                }
            }
            //Draw Cars as they must go behind buildings and lights
            if (drawCars)
            {
                foreach (ImageTile car in map.Cars)
                {
                    string fileName = string.Format("{0}\\{1}{2}", LOCATION_CARS, CARS[car.ImageIndex], ".png");
                    InsertImageTile(canvas, fileName, car);
                }
            }
            //Draw Buildings in middle layer
            if (drawBuildings)
            {
                foreach (ImageTile building in map.Buildings)
                {
                    string fileName = string.Format("{0}\\{1}{2}", LOCATION_BUILDINGS, BUILDINGS[building.ImageIndex], ".png");
                    InsertImageTile(canvas, fileName, building);
                }
            }
            //Draw Lights in front of everything else
            if (drawLights)
            {
                foreach (ImageTile pole in map.Lights)
                {
                    string fileName = string.Format("{0}\\{1}{2}", LOCATION_LIGHTS, LIGHTS[pole.ImageIndex], ".png");
                    InsertImageTile(canvas, fileName, pole);
                }
            }
        }
        public static Image DrawTileFromResource(Canvas canvas, int mapX, int mapY, int tileWidth, int tileHeight, string filename)
        {
            int xPos = tileWidth * mapX;
            if (mapY % 2 != 0)
                xPos = tileWidth * mapX + tileWidth / 2;
            int yPos = tileHeight / 2 * mapY;
            var img = AddImage(canvas, filename, xPos, yPos);
            img.Tag = new Point(mapX, mapY);//Store the original map x,y in the image tag
            return img;
        }
        public static Image AddImage(Canvas canvas, string fileName, double X, double Y)
        {
            Image ctrl = new Image
            {
                Source = new BitmapImage(new Uri(fileName))
            };
            canvas.Children.Add(ctrl);
            Canvas.SetLeft(ctrl, X);
            Canvas.SetTop(ctrl, Y);
            return ctrl;
        }
        public static BitmapImage GetTileImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_TILES, TILES[imageIndex])));
        }
        public static BitmapImage GetCarImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_CARS, CARS[imageIndex])));
        }
        public static BitmapImage GetBuildingImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_BUILDINGS, BUILDINGS[imageIndex])));
        }
        public static BitmapImage GetLightImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_LIGHTS, LIGHTS[imageIndex])));
        }
        public static int GetPreviousTemplateImageIndex(TileTemplate template)
        {
            //Sequence: ImageIndexSE, ImageIndexNE, ImageIndexSW, ImageIndexNW
            if (template.ImageIndex == template.ImageIndexSE && template.ImageIndexNW >= 0)
                return template.ImageIndexNW;
            else if (template.ImageIndex == template.ImageIndexNW && template.ImageIndexSW >= 0)
                return template.ImageIndexSW;
            else if (template.ImageIndex == template.ImageIndexSW && template.ImageIndexNE >= 0)
                return template.ImageIndexNE;
            else
                return template.ImageIndexSE;
        }
        public static int GetNextTemplateImageIndex(TileTemplate template)
        {
            //Sequence: ImageIndexSE, ImageIndexNE, ImageIndexSW, ImageIndexNW
            if (template.ImageIndex == template.ImageIndexSE)
            {
                if (template.ImageIndexNE >= 0)
                    return template.ImageIndexNE;
                else if (template.ImageIndexSW >= 0)
                    return template.ImageIndexSW;
                else
                    return template.ImageIndexNW;
            }
            else if (template.ImageIndex == template.ImageIndexNE && template.ImageIndexSW >= 0)
                return template.ImageIndexSW;
            else if (template.ImageIndex == template.ImageIndexSW && template.ImageIndexNW >= 0)
                return template.ImageIndexNW;
            else
                return template.ImageIndexSE;
        }
        private static Image DrawTile(Canvas canvas, GroundTile tile, int tileWidth, int tileHeight)
        {
            string filename = string.Format("{0}\\{1}{2}", LOCATION_TILES, TILES[tile.TileIndex], ".png");
            int xPos = tileWidth * tile.MapX;
            if (tile.MapY % 2 != 0)
                xPos = tileWidth * tile.MapX + tileWidth / 2;
            int yPos = tileHeight / 2 * tile.MapY;
            var img = AddImage(canvas, filename, xPos, yPos);
            img.Tag = tile;//Store the original groundtile in the image tag
            return img;
        }
        private static void InsertImageTile(Canvas canvas, string fileName, ImageTile imageTile)
        {
            var img = AddImage(canvas, fileName, imageTile.StartXPosition, imageTile.StartYPosition);
            img.Tag = imageTile;
            img.Opacity = imageTile.Opacity;
            imageTile.CurrentImage = img;
        }
        public static Point ScreenPositionFromMapCoords(Map map, int mapX, int mapY)
        {
            int xPos = map.TileWidth * mapX;
            if (mapY % 2 != 0)
                xPos = map.TileWidth * mapX + map.TileWidth / 2;
            int yPos = map.TileHeight / 2 * mapY;
            return new Point(xPos, yPos);
        }
        public static Point MapCoordsFromScreenPosition(Map map, double x, double y)
        {
            //Calculate approxmate map coordinates from the specified screen position
            int mapWidth = map.TileMap.GetLength(0);
            int mapHeight = map.TileMap.GetLength(1);
            int mapX = (int)(x / map.TileWidth);
            int mapY = (int)(y / (map.TileHeight / 2));
            //Bounds checking
            if (mapX >= mapWidth)
                mapX = mapWidth - 1;
            if (mapY >= mapHeight)
                mapY = mapHeight - 1;

            //check at mapX
            if (PointInTile(x, y, map.TileMap[mapX, mapY], map.TileWidth, map.TileHeight))
                return new Point(mapX, mapY);
            else if (mapY > 0 && PointInTile(x, y, map.TileMap[mapX, mapY - 1], map.TileWidth, map.TileHeight))
                return new Point(mapX, mapY - 1);
            else if (mapY < mapWidth - 1 && PointInTile(x, y, map.TileMap[mapX, mapY + 1], map.TileWidth, map.TileHeight))
                return new Point(mapX, mapY + 1);
            //check at mapX - 1
            else if (mapX > 0)
            {
                if (PointInTile(x, y, map.TileMap[mapX - 1, mapY], map.TileWidth, map.TileHeight))
                    return new Point(mapX - 1, mapY);
                else if (mapY > 0 && PointInTile(x, y, map.TileMap[mapX - 1, mapY - 1], map.TileWidth, map.TileHeight))
                    return new Point(mapX - 1, mapY - 1);
                else if (mapY < mapWidth - 1 && PointInTile(x, y, map.TileMap[mapX - 1, mapY + 1], map.TileWidth, map.TileHeight))
                    return new Point(mapX - 1, mapY + 1);
            }
            //we are outside the map
            return new Point(-1, -1);
        }
        private static bool PointInTile(double x, double y, GroundTile tile, int tileWidth, int tileHeight)
        {
            //get the rectangular bounds of the tile (remember to offset x-pos when mapY is Odd)
            int xOffset = tileWidth * tile.MapX;
            if (tile.MapY % 2 != 0)
                xOffset = tileWidth * tile.MapX + tileWidth / 2;
            int yOffset = tileHeight / 2 * tile.MapY;

            var p1 = new Point(xOffset, yOffset + tileHeight / 2);
            var p2 = new Point(xOffset + tileWidth / 2, yOffset);
            var p3 = new Point(xOffset + tileWidth / 2, yOffset + tileHeight);
            if (GeometryHelpers.PointInParralellogram(new Point(x, y), p1, p2, p3))
                return true;
            else
                return false;
        }
    }
}
